import {Component, Input, OnInit} from '@angular/core';
import {ItemGroup} from "../../../../project/game-model/inventory/ItemGroup";
import {Item} from "../../../../project/game-model/inventory/Item";
import {MatTableDataSource} from "@angular/material/table";
import {ItemgroupCharacteristicValue} from "../../../../project/game-model/inventory/ItemgroupCharacteristicValue";

@Component({
  selector: 'app-inherited-item-characteristic-editor',
  templateUrl: './inherited-item-characteristic-editor.component.html',
  styleUrl: './inherited-item-characteristic-editor.component.scss'
})
export class InheritedItemCharacteristicEditorComponent implements OnInit{

  @Input() inheritedItemgroup: ItemGroup | undefined
  @Input() item: Item | undefined

  datasource: MatTableDataSource<ItemgroupCharacteristicValue> = new MatTableDataSource<ItemgroupCharacteristicValue>();
  displayedColumns: string[] = ['characteristic', 'value', 'edit']
  editedItemgroupCharacteristicValue: ItemgroupCharacteristicValue | undefined

  ngOnInit() {
    this.item!.initializeItemCharacteristics();
    this.datasource.data = this.findCharacteristicValuesByItemgroup(this.inheritedItemgroup!);
  }


  findCharacteristicValuesByItemgroup(itemGroup: ItemGroup): ItemgroupCharacteristicValue[] {
    const result = this.item?.itemCharacteristicValues.filter(value => value.key.itemgroup.componentName === itemGroup.componentName);
    if(result != undefined) {
      return result;
    }
    return []
  }

  editCharacteristicValue(itemCharacteristicValue: ItemgroupCharacteristicValue): void {
    this.editedItemgroupCharacteristicValue = itemCharacteristicValue;
  }

  finishEditing() {
    this.editedItemgroupCharacteristicValue = undefined;
  }
}
